<template>
  <div>
    <filter-panel/>
    <ob-table
        ref="ob-table"
        :columns="columns"
        :functionalPanel="true"
        :filter-buttons="!isOrderAll ? filterButtons : []"
        @select="openInNewTab"
        @on-change-filter-button="onChangeFilterButton"
        is-fixed-header
        :is-functional-sort="false"
        :is-functional-group="false"
        :remote-opt="{
          method: getCarrierOrders,
          arguments: {
            url: $route.query.tab
          }
        }"
        :remote-trigger="$route.query"
        data-qa="orderListTable"
        class="orders-page"
        :component-unique-key="$uniqueTableKeys.AccountPerformerOrdersCarrier"
    >

      <div slot="typeOrder" slot-scope="{data}">
        <type-order :order="data.item"/>
      </div>
      <div slot="caution" slot-scope="{data}">
        <caution :info="data.item"/>
      </div>
      <div slot="route" slot-scope="{data}">
        <routes
            :start-address="data.item.startAddress"
            :end-address="data.item.endAddress"
            :count="0"
        />
      </div>
      <div slot="isResourceNumber" slot-scope="{data}">
        <registration-number :resourceNumber="data.item.resourceNumber"/>
      </div>
      <div slot="spotQuota" slot-scope="{data}">
        <spot-quota :data="data.item" />
      </div>

      <table-is-empty slot="noneContent"/>

    </ob-table>
  </div>
</template>

<script>
  import FilterPanel from "../../filterPanel";
  import ObTable from 'common-components/src/obComponents/obTable';
  import commonMethods from '@/mixins/order-list-mixin.js';
  import {statusTitleMap} from '@/mixins/order-list-mixin.js';
  import TypeOrder from "../slots/typeOrder";
  import Caution from "../slots/caution";
  import Routes from "../slots/routes";
  import SpotQuota from "../slots/spotQuota";
  import registrationNumber from "../slots/registrationNumber";
  import TableIsEmpty from "../tableIsEmpty";
  import {DateTime} from "luxon";
  import {formatNumber} from "common-components/src/helpers/common";

  export default {
    name: "carrier",
    components: {
      FilterPanel,
      ObTable,
      TypeOrder,
      Caution,
      Routes,
      registrationNumber,
      TableIsEmpty,
      SpotQuota
    },
    mixins: [
      commonMethods
    ],
    data() {
      return {
        filterButtons: [
          {
            title: 'Все',
            uuid: 'EXECUTABLE_ALL',
            _isActive: true
          },
          {
            html: '<span style="font-size: 18px; color: red" class="icon inherit clock"/>',
            _isActive: false
          },
          {
            title: 'Подготовка исполнения',
            uuid: 'PREPARATION_TO_EXECUTION',
            _isActive: false
          },
          {
            title: 'К подаче',
            uuid: 'CONTRACTED',
            _isActive: false
          },
          {
            title: 'В пути',
            uuid: 'IN_PROCESS',
            _isActive: false
          }
        ],
        columns: [
          {
            title: '',
            key: 'typeOrder',
            slotName: 'typeOrder',
            sortDisable: true
          },
          {
            title: '№ заказа клиента',
            key: 'parentOrderNumber',
            width: 140
          },
          {
            title: '№ заказа перевозчика',
            key: 'number',
            width: 140
          },
          {
            title: 'Спот, квота',
            key: 'spotQuota',
            slotName: 'spotQuota',
            sortDisable: true
          },
          {
            title: 'Внешний № заказа клиента',
            key: '',
            html: ({externalNumber}) => this.transformText(externalNumber)
          },
          {
            title: 'дата создания',
            key: 'createdAt',
            html: (data) => data.createdAt
              ? DateTime.fromISO(data.createdAt).toFormat("dd.MM.yyyy")
              : DateTime.local().toFormat("dd.MM.yyyy"),
          },
          {
            title: 'План: погрузка',
            key: 'pvpDate',
            html: (data) => data.pvpDate
              ? DateTime.fromISO(data.pvpDate).toFormat("dd.MM.yyyy")
              : 'Не указано',
          },
          {
            title: 'статус',
            key: 'status',
            html: ({status}) => statusTitleMap[status]
          },
          {
            title: 'Маршрут',
            key: 'route',
            slotName: 'route'
          },
          {
            title: "Грузовладелец",
            key: "cargoOwnerTitle",
            width: 220,
            html: ({cargoOwnerTitle}) => cargoOwnerTitle ? cargoOwnerTitle : '-'
          },
          {
            title: 'сумма без ндс',
            key: 'totalPriceWithoutVat',
            isAlignRight: true,
            html: ({ orderCost }) =>
              `<div class="price-right">
                <span style="white-space: nowrap;">
                  ${formatNumber(orderCost?.priceWithoutVat / 100, { dot: 2 }) + " ₽"}
                </span>
              </div>`
          },
          {
            title: this.isTab === "carrier" ? 'НДС перевозчика' : 'ндс',
            key: 'vatValue',
            isAlignRight: true,
            html: ({ orderCost }) =>
              `<div class="price-right">
                <span style="white-space: nowrap;">
                  ${formatNumber(orderCost?.vatPrice / 100, { dot: 2 }) + " ₽"}
                </span>
              </div>`
          },
          {
            title: 'сумма итого',
            key: 'totalPrice',
            isAlignRight: true,
            html: ({ orderCost }) =>
              `<div class="price-right">
                <span style="white-space: nowrap;">
                  ${formatNumber(orderCost?.priceWithVat / 100, { dot: 2 }) + " ₽"}
                </span>
              </div>`
          },
          {
            title: "Перевозчик",
            key: "contractorTitle",
            width: 220,
            html: ({contractorTitle}) => contractorTitle ? contractorTitle : '-'
          },
          {
            title: "Тягач",
            key: "resourceNumber",
            width: 220,
            slotName: 'isResourceNumber'
          },
          {
            title: "Водитель",
            key: "fio",
            width: 220,
            html: ({fio}) => fio ? fio : 'Не указан'
          },
          {
            title: '№ шипмента',
            key: 'shipments',
            html: ({shipments}) => this.hasShipments(shipments)
          }
        ],
        statusTitleMap: statusTitleMap
      }
    }
  }
</script>
